# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------
DEVTYPE_EZI_MOTIONLINK2 = 1
DEVNAME_EZI_MOTIONLINK2 = "Ezi-MotionLink2"


# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------


class EZIMOTIONLINK2_AXISSTATUS:
    FFLAG_ERRSERVOALARM = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_RESERVED2 = 0x00000080
    FFLAG_RESERVED3 = 0x00000100
    FFLAG_RESERVED4 = 0x00000200
    FFLAG_RESERVED5 = 0x00000400
    FFLAG_RESERVED6 = 0x00000800
    FFLAG_RESERVED7 = 0x00001000
    FFLAG_RESERVED8 = 0x00002000
    FFLAG_RESERVED9 = 0x00004000
    FFLAG_RESERVED10 = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
MOTIONLINK2_IN_BITMASK_LIMITP = 0x00000001
MOTIONLINK2_IN_BITMASK_LIMITN = 0x00000002
MOTIONLINK2_IN_BITMASK_ORIGIN = 0x00000004
MOTIONLINK2_IN_BITMASK_CLEARPOSITION = 0x00000008
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000010
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000020
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000040
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000080
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000100
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000200
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000400
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00000800
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00001000
MOTIONLINK2_IN_BITMASK_STOP = 0x00002000
MOTIONLINK2_IN_BITMASK_PJOG = 0x00004000
MOTIONLINK2_IN_BITMASK_NJOG = 0x00008000
MOTIONLINK2_IN_BITMASK_ALARMRESET = 0x00010000
MOTIONLINK2_IN_BITMASK_SERVOON = 0x00020000
MOTIONLINK2_IN_BITMASK_PAUSE = 0x00040000
MOTIONLINK2_IN_BITMASK_ORIGINSEARCH = 0x00080000
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00100000
MOTIONLINK2_IN_BITMASK_ESTOP = 0x00200000
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00400000
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x00800000
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x01000000
# MOTIONLINK2_IN_BITMASK_RESERVED = 0x02000000
MOTIONLINK2_IN_BITMASK_USERIN0 = 0x04000000
MOTIONLINK2_IN_BITMASK_USERIN1 = 0x08000000
MOTIONLINK2_IN_BITMASK_USERIN2 = 0x10000000
MOTIONLINK2_IN_BITMASK_USERIN3 = 0x20000000
MOTIONLINK2_IN_BITMASK_USERIN4 = 0x40000000
MOTIONLINK2_IN_BITMASK_USERIN5 = 0x80000000

# Output Bit-mask list
MOTIONLINK2_OUT_BITMASK_COMPAREOUT = 0x00000001
MOTIONLINK2_OUT_BITMASK_INPOSITION = 0x00000002
MOTIONLINK2_OUT_BITMASK_ALARM = 0x00000004
MOTIONLINK2_OUT_BITMASK_MOVING = 0x00000008
MOTIONLINK2_OUT_BITMASK_ACCDEC = 0x00000010
MOTIONLINK2_OUT_BITMASK_ACK = 0x00000020
MOTIONLINK2_OUT_BITMASK_END = 0x00000040
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00000080
MOTIONLINK2_OUT_BITMASK_ORGSEARCHOK = 0x00000100
MOTIONLINK2_OUT_BITMASK_SERVOREADY = 0x00000200
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00000400
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00000800
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00001000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00002000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00004000
MOTIONLINK2_OUT_BITMASK_USEROUT0 = 0x00008000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00010000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00020000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00040000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00080000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00100000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00200000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00400000
# MOTIONLINK2_OUT_BITMASK_RESERVED = 0x00800000



# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

MOTIONLINK2_IN_PREASSIGN_LIMITP = 1
MOTIONLINK2_IN_PREASSIGN_LIMITN = 2
MOTIONLINK2_IN_PREASSIGN_ORIGIN = 3

MOTIONLINK2_IN_LOGIC_CLEARPOSITION = 4
MOTIONLINK2_IN_LOGIC_RESERVED0 = 5
MOTIONLINK2_IN_LOGIC_RESERVED1 = 6
MOTIONLINK2_IN_LOGIC_RESERVED2 = 7
MOTIONLINK2_IN_LOGIC_RESERVED3 = 8
MOTIONLINK2_IN_LOGIC_RESERVED4 = 9
MOTIONLINK2_IN_LOGIC_RESERVED5 = 10
MOTIONLINK2_IN_LOGIC_RESERVED6 = 11
MOTIONLINK2_IN_LOGIC_RESERVED7 = 12
MOTIONLINK2_IN_LOGIC_PTSTART = 13
MOTIONLINK2_IN_LOGIC_STOP = 14
MOTIONLINK2_IN_LOGIC_PJOG = 15
MOTIONLINK2_IN_LOGIC_NJOG = 16
MOTIONLINK2_IN_LOGIC_ALARMRESET = 17
MOTIONLINK2_IN_LOGIC_SERVOON = 18
MOTIONLINK2_IN_LOGIC_RESERVED8 = 19
MOTIONLINK2_IN_LOGIC_ORIGINSEARCH = 20
MOTIONLINK2_IN_LOGIC_RESERVED9 = 21
MOTIONLINK2_IN_LOGIC_ESTOP = 22
MOTIONLINK2_IN_LOGIC_RESERVED10 = 23
MOTIONLINK2_IN_LOGIC_RESERVED11 = 24
MOTIONLINK2_IN_LOGIC_RESERVED12 = 25
MOTIONLINK2_IN_LOGIC_RESERVED13 = 26
MOTIONLINK2_IN_LOGIC_USERIN0 = 27
MOTIONLINK2_IN_LOGIC_USERIN1 = 28
MOTIONLINK2_IN_LOGIC_USERIN2 = 29
MOTIONLINK2_IN_LOGIC_USERIN3 = 30
MOTIONLINK2_IN_LOGIC_USERIN4 = 31
MOTIONLINK2_IN_LOGIC_RESERVED14 = 32

MAX_MOTIONLINK2_IN_LOGIC = 33

MOTIONLINK2_OUT_PREASSIGN_COMP = 1

MOTIONLINK2_OUT_LOGIC_INPOSITION = 2
MOTIONLINK2_OUT_LOGIC_ALARM = 3
MOTIONLINK2_OUT_LOGIC_MOVING = 4
MOTIONLINK2_OUT_LOGIC_ACCDEC = 5
MOTIONLINK2_OUT_LOGIC_RESERVED0 = 6
MOTIONLINK2_OUT_LOGIC_RESERVED1 = 7
MOTIONLINK2_OUT_LOGIC_RESERVED2 = 8
MOTIONLINK2_OUT_LOGIC_ORGSEARCHOK = 9
MOTIONLINK2_OUT_LOGIC_RESERVED3 = 10
MOTIONLINK2_OUT_LOGIC_RESERVED4 = 11
MOTIONLINK2_OUT_LOGIC_RESERVED5 = 12
MOTIONLINK2_OUT_LOGIC_RESERVED6 = 13
MOTIONLINK2_OUT_LOGIC_RESERVED7 = 14
MOTIONLINK2_OUT_LOGIC_RESERVED8 = 15
MOTIONLINK2_OUT_LOGIC_USEROUT0 = 16
MOTIONLINK2_OUT_LOGIC_USEROUT1 = 17
MOTIONLINK2_OUT_LOGIC_USEROUT2 = 18
MOTIONLINK2_OUT_LOGIC_RESERVED9 = 19
MOTIONLINK2_OUT_LOGIC_RESERVED10 = 20
MOTIONLINK2_OUT_LOGIC_RESERVED11 = 21
MOTIONLINK2_OUT_LOGIC_RESERVED12 = 22
MOTIONLINK2_OUT_LOGIC_RESERVED13 = 23
MOTIONLINK2_OUT_LOGIC_RESERVED14 = 24

MAX_MOTIONLINK2_OUT_LOGIC = 25


MOTIONLINK2_IN_PIN_CNT = 8
MOTIONLINK2_OUT_PIN_CNT = 4

MOTIONLINK2_IN_LOGIC_CNT = MAX_MOTIONLINK2_IN_LOGIC - 1
MOTIONLINK2_MAX_PREASSIGNED_IN = MOTIONLINK2_IN_PREASSIGN_ORIGIN

MOTIONLINK2_OUT_LOGIC_CNT = MAX_MOTIONLINK2_OUT_LOGIC - 1
MOTIONLINK2_MAX_PREASSIGNED_OUT = MOTIONLINK2_OUT_PREASSIGN_COMP

# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------

MOTIONLINK2_ENCODERMULTIPLY = 0
MOTIONLINK2_AXISMAXSPEED = 1
MOTIONLINK2_AXISSTARTSPEED = 2
MOTIONLINK2_AXISACCTIME = 3
MOTIONLINK2_AXISDECTIME = 4

MOTIONLINK2_SPEEDOVERRIDE = 5
MOTIONLINK2_JOGHIGHSPEED = 6
MOTIONLINK2_JOGLOWSPEED = 7
MOTIONLINK2_JOGACCDECTIME = 8

MOTIONLINK2_SWLMTPLUSVALUE = 9
MOTIONLINK2_SWLMTMINUSVALUE = 10
MOTIONLINK2_SOFTLMTSTOPMETHOD = 11
MOTIONLINK2_HARDLMTSTOPMETHOD = 12
MOTIONLINK2_LIMITSENSORLOGIC = 13

MOTIONLINK2_ORGSPEED = 14
MOTIONLINK2_ORGSEARCHSPEED = 15
MOTIONLINK2_ORGACCDECTIME = 16
MOTIONLINK2_ORGMETHOD = 17
MOTIONLINK2_ORGDIR = 18
MOTIONLINK2_ORGOFFSET = 19
MOTIONLINK2_ORGPOSITIONSET = 20
MOTIONLINK2_ORGSENSORLOGIC = 21

MOTIONLINK2_LIMITSENSORDIR = 22
MOTIONLINK2_PULSETYPE = 23
MOTIONLINK2_ENCODERDIR = 24
MOTIONLINK2_MOTIONDIR = 25

MOTIONLINK2_SERVOALARMRESETLOGIC = 26
MOTIONLINK2_SERVOONOUTPUTLOGIC = 27
MOTIONLINK2_SERVOALARMLOGIC = 28

MOTIONLINK2_SERVOINPOSLOGIC = 29

MOTIONLINK2_SPARE2 = 30
MOTIONLINK2_SPARE3 = 31
MOTIONLINK2_SPARE4 = 32
MOTIONLINK2_SPARE5 = 33

MAX_MOTIONLINK2_PARAM = 34

# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

MOTIONLINK2_MAX_ITEM_COUNT = 64
