# -*- coding: utf-8 -*-
#------------------------------------------------------------------
#                 Device Type Defines.
#------------------------------------------------------------------
DEVTYPE_EZI_MOTIONLINK = 10
DEVNAME_EZI_MOTIONLINK = "Ezi-MotionLink"

#------------------------------------------------------------------
#                 Axis Status Flag Defines.
#------------------------------------------------------------------

class EZIMOTIONLINK_AXISSTATUS:
    FFLAG_ERRSERVOALARM = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_RESERVED2 = 0x00000080
    FFLAG_RESERVED3 = 0x00000100
    FFLAG_RESERVED4 = 0x00000200
    FFLAG_RESERVED5 = 0x00000400
    FFLAG_RESERVED6 = 0x00000800
    FFLAG_RESERVED7 = 0x00001000
    FFLAG_RESERVED8 = 0x00002000
    FFLAG_RESERVED9 = 0x00004000
    FFLAG_RESERVED10 = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


#------------------------------------------------------------------
#                 Input/Output Defines.
#------------------------------------------------------------------

# Input Bit-mask list
MOTIONLINK_IN_BITMASK_LIMITP = 0x00000001
MOTIONLINK_IN_BITMASK_LIMITN = 0x00000002
MOTIONLINK_IN_BITMASK_ORIGIN = 0x00000004
MOTIONLINK_IN_BITMASK_CLEARPOSITION = 0x00000008
MOTIONLINK_IN_BITMASK_PTA0 = 0x00000010
MOTIONLINK_IN_BITMASK_PTA1 = 0x00000020
MOTIONLINK_IN_BITMASK_PTA2 = 0x00000040
MOTIONLINK_IN_BITMASK_PTA3 = 0x00000080
MOTIONLINK_IN_BITMASK_PTA4 = 0x00000100
MOTIONLINK_IN_BITMASK_PTA5 = 0x00000200
# MOTIONLINK_IN_BITMASK_RESERVED = 0x00000400
# MOTIONLINK_IN_BITMASK_RESERVED = 0x00000800
MOTIONLINK_IN_BITMASK_PTSTART = 0x00001000
MOTIONLINK_IN_BITMASK_STOP = 0x00002000
MOTIONLINK_IN_BITMASK_PJOG = 0x00004000
MOTIONLINK_IN_BITMASK_NJOG = 0x00008000
MOTIONLINK_IN_BITMASK_ALARMRESET = 0x00010000
MOTIONLINK_IN_BITMASK_SERVOON = 0x00020000
MOTIONLINK_IN_BITMASK_PAUSE = 0x00040000
MOTIONLINK_IN_BITMASK_ORIGINSEARCH = 0x00080000
MOTIONLINK_IN_BITMASK_TEACHING = 0x00100000
MOTIONLINK_IN_BITMASK_ESTOP = 0x00200000
MOTIONLINK_IN_BITMASK_JPTIN0 = 0x00400000
MOTIONLINK_IN_BITMASK_JPTIN1 = 0x00800000
MOTIONLINK_IN_BITMASK_JPTIN2 = 0x01000000
MOTIONLINK_IN_BITMASK_JPTSTART = 0x02000000
MOTIONLINK_IN_BITMASK_USERIN0 = 0x04000000
MOTIONLINK_IN_BITMASK_USERIN1 = 0x08000000
MOTIONLINK_IN_BITMASK_USERIN2 = 0x10000000
MOTIONLINK_IN_BITMASK_USERIN3 = 0x20000000
MOTIONLINK_IN_BITMASK_USERIN4 = 0x40000000
MOTIONLINK_IN_BITMASK_USERIN5 = 0x80000000
MOTIONLINK_IN_BITMASK_USERIN6 = 0x00000200

# Output Bit-mask list
MOTIONLINK_OUT_BITMASK_COMPAREOUT = 0x00000001
MOTIONLINK_OUT_BITMASK_INPOSITION = 0x00000002
MOTIONLINK_OUT_BITMASK_ALARM = 0x00000004
MOTIONLINK_OUT_BITMASK_MOVING = 0x00000008
MOTIONLINK_OUT_BITMASK_ACCDEC = 0x00000010
MOTIONLINK_OUT_BITMASK_ACK = 0x00000020
MOTIONLINK_OUT_BITMASK_END = 0x00000040
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00000080
MOTIONLINK_OUT_BITMASK_ORGSEARCHOK = 0x00000100
MOTIONLINK_OUT_BITMASK_SERVOREADY = 0x00000200
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00000400
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00000800
MOTIONLINK_OUT_BITMASK_PTOUT0 = 0x00001000
MOTIONLINK_OUT_BITMASK_PTOUT1 = 0x00002000
MOTIONLINK_OUT_BITMASK_PTOUT2 = 0x00004000
MOTIONLINK_OUT_BITMASK_USEROUT0 = 0x00008000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00010000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00020000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00040000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00080000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00100000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00200000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00400000
# MOTIONLINK_OUT_BITMASK_RESERVED = 0x00800000


#------------------------------------------------------------------
#                 Input/Output Assigning Defines.
#------------------------------------------------------------------

MOTIONLINK_IN_PREASSIGN_LIMITP = 1
MOTIONLINK_IN_PREASSIGN_LIMITN = 2
MOTIONLINK_IN_PREASSIGN_ORIGIN = 3

MOTIONLINK_IN_LOGIC_CLEARPOSITION = 4
MOTIONLINK_IN_LOGIC_PTA0 = 5
MOTIONLINK_IN_LOGIC_PTA1 = 6
MOTIONLINK_IN_LOGIC_PTA2 = 7
MOTIONLINK_IN_LOGIC_PTA3 = 8
MOTIONLINK_IN_LOGIC_PTA4 = 9
MOTIONLINK_IN_LOGIC_PTA5 = 10
MOTIONLINK_IN_LOGIC_RESERVED0 = 11
MOTIONLINK_IN_LOGIC_RESERVED1 = 12
MOTIONLINK_IN_LOGIC_PTSTART = 13
MOTIONLINK_IN_LOGIC_STOP = 14
MOTIONLINK_IN_LOGIC_PJOG = 15
MOTIONLINK_IN_LOGIC_NJOG = 16
MOTIONLINK_IN_LOGIC_ALARMRESET = 17
MOTIONLINK_IN_LOGIC_SERVOON = 18
MOTIONLINK_IN_LOGIC_PAUSE = 19
MOTIONLINK_IN_LOGIC_ORIGINSEARCH = 20
MOTIONLINK_IN_LOGIC_TEACHING = 21
MOTIONLINK_IN_LOGIC_ESTOP = 22
MOTIONLINK_IN_LOGIC_JPTIN0 = 23
MOTIONLINK_IN_LOGIC_JPTIN1 = 24
MOTIONLINK_IN_LOGIC_JPTIN2 = 25
MOTIONLINK_IN_LOGIC_JPTSTART = 26
MOTIONLINK_IN_LOGIC_USERIN0 = 27
MOTIONLINK_IN_LOGIC_USERIN1 = 28
MOTIONLINK_IN_LOGIC_USERIN2 = 29
MOTIONLINK_IN_LOGIC_USERIN3 = 30
MOTIONLINK_IN_LOGIC_USERIN4 = 31
MOTIONLINK_IN_LOGIC_USERIN5 = 32

MAX_MOTIONLINK_IN_LOGIC = 33

MOTIONLINK_OUT_PREASSIGN_COMP = 1

MOTIONLINK_OUT_LOGIC_INPOSITION = 2
MOTIONLINK_OUT_LOGIC_ALARM = 3
MOTIONLINK_OUT_LOGIC_MOVING = 4
MOTIONLINK_OUT_LOGIC_ACCDEC = 5
MOTIONLINK_OUT_LOGIC_ACK = 6
MOTIONLINK_OUT_LOGIC_END = 7
MOTIONLINK_OUT_LOGIC_RESERVED0 = 8
MOTIONLINK_OUT_LOGIC_ORGSEARCHOK = 9
MOTIONLINK_OUT_LOGIC_SERVOREADY = 10
MOTIONLINK_OUT_LOGIC_RESERVED1 = 11
MOTIONLINK_OUT_LOGIC_RESERVED2 = 12
MOTIONLINK_OUT_LOGIC_PTOUT0 = 13
MOTIONLINK_OUT_LOGIC_PTOUT1 = 14
MOTIONLINK_OUT_LOGIC_PTOUT2 = 15
MOTIONLINK_OUT_LOGIC_USEROUT0 = 16
MOTIONLINK_OUT_LOGIC_RESERVED3 = 17
MOTIONLINK_OUT_LOGIC_RESERVED4 = 18
MOTIONLINK_OUT_LOGIC_RESERVED5 = 19
MOTIONLINK_OUT_LOGIC_RESERVED6 = 20
MOTIONLINK_OUT_LOGIC_RESERVED7 = 21
MOTIONLINK_OUT_LOGIC_RESERVED8 = 22
MOTIONLINK_OUT_LOGIC_RESERVED9 = 23
MOTIONLINK_OUT_LOGIC_RESERVED10 = 24

MAX_MOTIONLINK_OUT_LOGIC = 25

MOTIONLINK_IN_PIN_CNT	= 10
MOTIONLINK_OUT_PIN_CNT	= 2

MOTIONLINK_IN_LOGIC_CNT			= (MAX_MOTIONLINK_IN_LOGIC - 1)
MOTIONLINK_MAX_PREASSIGNED_IN	= (MOTIONLINK_IN_PREASSIGN_ORIGIN)

MOTIONLINK_OUT_LOGIC_CNT		= (MAX_MOTIONLINK_OUT_LOGIC - 1)
MOTIONLINK_MAX_PREASSIGNED_OUT	= (MOTIONLINK_OUT_PREASSIGN_COMP)

#------------------------------------------------------------------
#                 Parameters Defines.
#------------------------------------------------------------------

MOTIONLINK_ENCODERMULTIPLY = 0
MOTIONLINK_AXISMAXSPEED = 1
MOTIONLINK_AXISSTARTSPEED = 2
MOTIONLINK_AXISACCTIME = 3
MOTIONLINK_AXISDECTIME = 4

MOTIONLINK_SPEEDOVERRIDE = 5
MOTIONLINK_JOGHIGHSPEED = 6
MOTIONLINK_JOGLOWSPEED = 7
MOTIONLINK_JOGACCDECTIME = 8

MOTIONLINK_EXTSERVOALARMLOGIC = 9
MOTIONLINK_EXTSERVOONLOGIC = 10
MOTIONLINK_EXTSERVORESETLOGIC = 11

MOTIONLINK_SWLMTPLUSVALUE = 12
MOTIONLINK_SWLMTMINUSVALUE = 13
MOTIONLINK_SOFTLMTSTOPMETHOD = 14
MOTIONLINK_HARDLMTSTOPMETHOD = 15
MOTIONLINK_LIMITSENSORLOGIC = 16

MOTIONLINK_ORGSPEED = 17
MOTIONLINK_ORGSEARCHSPEED = 18
MOTIONLINK_ORGACCDECTIME = 19
MOTIONLINK_ORGMETHOD = 20
MOTIONLINK_ORGDIR = 21
MOTIONLINK_ORGOFFSET = 22
MOTIONLINK_ORGPOSITIONSET = 23
MOTIONLINK_ORGSENSORLOGIC = 24

MOTIONLINK_LIMITSENSORDIR = 25
MOTIONLINK_PULSETYPE = 26
MOTIONLINK_ENCODERDIR = 27
MOTIONLINK_MOTIONDIR = 28

MOTIONLINK_SERVOALARMRESETLOGIC = 29
MOTIONLINK_SERVOONOUTPUTLOGIC = 30
MOTIONLINK_SERVOALARMLOGIC = 31

MOTIONLINK_SERVOINPOSLOGIC = 32

MOTIONLINK_SPARE2 = 33
MOTIONLINK_SPARE3 = 34
MOTIONLINK_SPARE4 = 35
MOTIONLINK_SPARE5 = 36

MAX_MOTIONLINK_PARAM = 37

#------------------------------------------------------------------
#                 POSITION TABLE Defines.
#------------------------------------------------------------------
MOTIONLINK_MAX_ITEM_COUNT = 64