# -*- coding: utf-8 -*-
#------------------------------------------------------------------
#                 Device Type Defines.
#------------------------------------------------------------------

DEVTYPE_EZI_SERVO_PLUS_R_ALL_28_V2 = 108
DEVNAME_EZI_SERVO_PLUS_R_ALL_28_V2 = "Ezi-SERVO Plus-R ALL-28 V2"

#------------------------------------------------------------------
#                 Axis Status Flag Defines.
#------------------------------------------------------------------

class EZISERVO_ALL28_V2_AXISSTATUS:
    FFLAG_ERRORALL          = 0x00000001
    FFLAG_HWPOSILMT         = 0x00000002
    FFLAG_HWNEGALMT         = 0x00000004
    FFLAG_SWPOGILMT         = 0x00000008
    FFLAG_SWNEGALMT         = 0x00000010
    FFLAG_RESERVED0         = 0x00000020
    FFLAG_RESERVED1         = 0x00000040
    FFLAG_ERRPOSOVERFLOW    = 0x00000080
    FFLAG_ERROVERCURRENT    = 0x00000100
    FFLAG_ERROVERSPEED      = 0x00000200
    FFLAG_ERRPOSTRACKING    = 0x00000400
    FFLAG_ERROVERLOAD       = 0x00000800
    FFLAG_ERROVERHEAT       = 0x00001000
    FFLAG_ERRBACKEMF        = 0x00002000
    FFLAG_ERRMOTORPOWER     = 0x00004000
    FFLAG_ERRINPOSITION     = 0x00008000
    FFLAG_EMGSTOP           = 0x00010000
    FFLAG_SLOWSTOP          = 0x00020000
    FFLAG_ORIGINRETURNING   = 0x00040000
    FFLAG_INPOSITION        = 0x00080000
    FFLAG_SERVOON           = 0x00100000
    FFLAG_ALARMRESET        = 0x00200000
    FFLAG_PTSTOPPED         = 0x00400000
    FFLAG_ORIGINSENSOR      = 0x00800000
    FFLAG_ZPULSE            = 0x01000000
    FFLAG_ORIGINRETOK       = 0x02000000
    FFLAG_MOTIONDIR         = 0x04000000
    FFLAG_MOTIONING         = 0x08000000
    FFLAG_RESERVED2         = 0x10000000
    FFLAG_MOTIONACCEL       = 0x20000000
    FFLAG_MOTIONDECEL       = 0x40000000
    FFLAG_MOTIONCONST       = 0x80000000

#------------------------------------------------------------------
#                 Input/Output Defines.
#------------------------------------------------------------------

SERVO_ALL28_V2_IN_BITMASK_LIMITP          = 0x00000001
SERVO_ALL28_V2_IN_BITMASK_LIMITN          = 0x00000002
SERVO_ALL28_V2_IN_BITMASK_ORIGIN          = 0x00000004
SERVO_ALL28_V2_IN_BITMASK_CLEARPOSITION   = 0x00000008
SERVO_ALL28_V2_IN_BITMASK_PTA0            = 0x00000010
SERVO_ALL28_V2_IN_BITMASK_PTA1            = 0x00000020
SERVO_ALL28_V2_IN_BITMASK_PTA2            = 0x00000040
SERVO_ALL28_V2_IN_BITMASK_PTA3            = 0x00000080
SERVO_ALL28_V2_IN_BITMASK_PTA4            = 0x00000100
SERVO_ALL28_V2_IN_BITMASK_PTA5            = 0x00000200
SERVO_ALL28_V2_IN_BITMASK_PTA6            = 0x00000400
SERVO_ALL28_V2_IN_BITMASK_PTA7            = 0x00000800
SERVO_ALL28_V2_IN_BITMASK_PTSTART         = 0x00001000
SERVO_ALL28_V2_IN_BITMASK_STOP            = 0x00002000
SERVO_ALL28_V2_IN_BITMASK_PJOG            = 0x00004000
SERVO_ALL28_V2_IN_BITMASK_NJOG            = 0x00008000
SERVO_ALL28_V2_IN_BITMASK_ALARMRESET      = 0x00010000
SERVO_ALL28_V2_IN_BITMASK_SERVOON         = 0x00020000
# SERVO_ALL28_V2_IN_BITMASK_RESERVED      = 0x00040000
SERVO_ALL28_V2_IN_BITMASK_ORIGINSEARCH    = 0x00080000
SERVO_ALL28_V2_IN_BITMASK_TEACHING        = 0x00100000
SERVO_ALL28_V2_IN_BITMASK_ESTOP           = 0x00200000
SERVO_ALL28_V2_IN_BITMASK_JPTIN0          = 0x00400000
SERVO_ALL28_V2_IN_BITMASK_JPTIN1          = 0x00800000
SERVO_ALL28_V2_IN_BITMASK_JPTIN2          = 0x01000000
SERVO_ALL28_V2_IN_BITMASK_JPTSTART        = 0x02000000
SERVO_ALL28_V2_IN_BITMASK_USERIN0         = 0x04000000
SERVO_ALL28_V2_IN_BITMASK_USERIN1         = 0x08000000
SERVO_ALL28_V2_IN_BITMASK_USERIN2         = 0x10000000
SERVO_ALL28_V2_IN_BITMASK_USERIN3         = 0x20000000
SERVO_ALL28_V2_IN_BITMASK_USERIN4         = 0x40000000
SERVO_ALL28_V2_IN_BITMASK_USERIN5         = 0x80000000


#------------------------------------------------------------------
#                 Input/Output Assigning Defines.
#------------------------------------------------------------------
SERVO_ALL28_V2_IN_LIMITP = 1
SERVO_ALL28_V2_IN_LIMITN = 2
SERVO_ALL28_V2_IN_ORIGIN = 3

SERVO_ALL28_V2_IN_LOGIC_CLEARPOSITION = 4
SERVO_ALL28_V2_IN_LOGIC_PTA0 = 5
SERVO_ALL28_V2_IN_LOGIC_PTA1 = 6
SERVO_ALL28_V2_IN_LOGIC_PTA2 = 7
SERVO_ALL28_V2_IN_LOGIC_PTA3 = 8
SERVO_ALL28_V2_IN_LOGIC_PTA4 = 9
SERVO_ALL28_V2_IN_LOGIC_PTA5 = 10
SERVO_ALL28_V2_IN_LOGIC_PTA6 = 11
SERVO_ALL28_V2_IN_LOGIC_PTA7 = 12
SERVO_ALL28_V2_IN_LOGIC_PTSTART = 13
SERVO_ALL28_V2_IN_LOGIC_STOP = 14
SERVO_ALL28_V2_IN_LOGIC_PJOG = 15
SERVO_ALL28_V2_IN_LOGIC_NJOG = 16
SERVO_ALL28_V2_IN_LOGIC_ALARMRESET = 17
SERVO_ALL28_V2_IN_LOGIC_SERVOON = 18
SERVO_ALL28_V2_IN_LOGIC_RESERVED0 = 19
SERVO_ALL28_V2_IN_LOGIC_ORIGINSEARCH = 20
SERVO_ALL28_V2_IN_LOGIC_TEACHING = 21
SERVO_ALL28_V2_IN_LOGIC_ESTOP = 22
SERVO_ALL28_V2_IN_LOGIC_JPTIN0 = 23
SERVO_ALL28_V2_IN_LOGIC_JPTIN1 = 24
SERVO_ALL28_V2_IN_LOGIC_JPTIN2 = 25
SERVO_ALL28_V2_IN_LOGIC_JPTSTART = 26
SERVO_ALL28_V2_IN_LOGIC_USERIN0 = 27
SERVO_ALL28_V2_IN_LOGIC_USERIN1 = 28
SERVO_ALL28_V2_IN_LOGIC_USERIN2 = 29
SERVO_ALL28_V2_IN_LOGIC_USERIN3 = 30
SERVO_ALL28_V2_IN_LOGIC_USERIN4 = 31
SERVO_ALL28_V2_IN_LOGIC_USERIN5 = 32

MAX_SERVO_ALL28_V2_IN_LOGIC = 33

SERVO_ALL28_V2_IN_PIN_CNT	= 4
SERVO_ALL28_V2_OUT_PIN_CNT	= 0

SERVO_ALL28_V2_IN_LOGIC_CNT		= (MAX_SERVO_ALL28_V2_IN_LOGIC - 1)
SERVO_ALL28_V2_MAX_PREASSIGNED_IN	= 0

SERVO_ALL28_V2_OUT_LOGIC_CNT		= 24
sSERVO_ALL28_V2_MAX_PREASSIGNED_OUT	= 0

#------------------------------------------------------------------
#                 Parameters Defines.
#------------------------------------------------------------------

SERVO_ALL28_V2_PULSEPERREVOLUTION = 0
SERVO_ALL28_V2_AXISMAXSPEED = 1
SERVO_ALL28_V2_AXISSTARTSPEED = 2
SERVO_ALL28_V2_AXISACCTIME = 3
SERVO_ALL28_V2_AXISDECTIME = 4

SERVO_ALL28_V2_RESERVED0 = 5
SERVO_ALL28_V2_JOGHIGHSPEED = 6
SERVO_ALL28_V2_JOGLOWSPEED = 7
SERVO_ALL28_V2_JOGACCDECTIME = 8

SERVO_ALL28_V2_SWLMTPLUSVALUE = 9
SERVO_ALL28_V2_SWLMTMINUSVALUE = 10
SERVO_ALL28_V2_SOFTLMTSTOPMETHOD = 11
SERVO_ALL28_V2_HARDLMTSTOPMETHOD = 12
SERVO_ALL28_V2_RESERVED1 = 13

SERVO_ALL28_V2_ORGSPEED = 14
SERVO_ALL28_V2_ORGSEARCHSPEED = 15
SERVO_ALL28_V2_ORGACCDECTIME = 16
SERVO_ALL28_V2_ORGMETHOD = 17
SERVO_ALL28_V2_ORGDIR = 18
SERVO_ALL28_V2_ORGOFFSET = 19
SERVO_ALL28_V2_ORGPOSITIONSET = 20
SERVO_ALL28_V2_RESERVED2 = 21

SERVO_ALL28_V2_POSITIONLOOPGAIN = 22
SERVO_ALL28_V2_INPOSITIONVALUE = 23
SERVO_ALL28_V2_POSTRACKINGLIMIT = 24
SERVO_ALL28_V2_MOTIONDIR = 25

SERVO_ALL28_V2_RESERVED3 = 26
SERVO_ALL28_V2_ORGTORQUERATIO = 27

SERVO_ALL28_V2_POSERROVERFLOWLIMIT = 28
SERVO_ALL28_V2_RESERVED4 = 29

SERVO_ALL28_V2_RUNCURRENT = 30
SERVO_ALL28_V2_BOOSTCURRENT = 31
SERVO_ALL28_V2_STOPCURRENT = 32

MAX_SERVO_ALL28_V2_PARAM = 33

#------------------------------------------------------------------
#                 POSITION TABLE Defines.
#------------------------------------------------------------------

SERVO_ALL28_V2_MAX_ITEM_COUNT = 256
