# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------

DEVTYPE_EZI_SERVO_PLUS_R_ALL_ABS = 35
DEVNAME_EZI_SERVO_PLUS_R_ALL_ABS = "Ezi-SERVO Plus-R-ALL Abs"


# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------
class EZISERVO_ALL_ABS_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_ERRPOSOVERFLOW = 0x00000080
    FFLAG_ERROVERCURRENT = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_ERRPOSTRACKING = 0x00000400
    FFLAG_ERROVERLOAD = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_ERRINPOSITION = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
SERVO_ALL_ABS_IN_BITMASK_LIMITP = 0x00000001
SERVO_ALL_ABS_IN_BITMASK_LIMITN = 0x00000002
SERVO_ALL_ABS_IN_BITMASK_ORIGIN = 0x00000004
SERVO_ALL_ABS_IN_BITMASK_CLEARPOSITION = 0x00000008
SERVO_ALL_ABS_IN_BITMASK_PTA0 = 0x00000010
SERVO_ALL_ABS_IN_BITMASK_PTA1 = 0x00000020
SERVO_ALL_ABS_IN_BITMASK_PTA2 = 0x00000040
SERVO_ALL_ABS_IN_BITMASK_PTA3 = 0x00000080
SERVO_ALL_ABS_IN_BITMASK_PTA4 = 0x00000100
SERVO_ALL_ABS_IN_BITMASK_PTA5 = 0x00000200
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x00000400
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x00000800
SERVO_ALL_ABS_IN_BITMASK_PTSTART = 0x00001000
SERVO_ALL_ABS_IN_BITMASK_STOP = 0x00002000
SERVO_ALL_ABS_IN_BITMASK_PJOG = 0x00004000
SERVO_ALL_ABS_IN_BITMASK_NJOG = 0x00008000
SERVO_ALL_ABS_IN_BITMASK_ALARMRESET = 0x00010000
SERVO_ALL_ABS_IN_BITMASK_SERVOON = 0x00020000
SERVO_ALL_ABS_IN_BITMASK_PAUSE = 0x00040000
SERVO_ALL_ABS_IN_BITMASK_ORIGINSEARCH = 0x00080000
SERVO_ALL_ABS_IN_BITMASK_TEACHING = 0x00100000
SERVO_ALL_ABS_IN_BITMASK_ESTOP = 0x00200000
SERVO_ALL_ABS_IN_BITMASK_JPTIN0 = 0x00400000
SERVO_ALL_ABS_IN_BITMASK_JPTIN1 = 0x00800000
SERVO_ALL_ABS_IN_BITMASK_JPTIN2 = 0x01000000
SERVO_ALL_ABS_IN_BITMASK_JPTSTART = 0x02000000
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x04000000
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x08000000
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x10000000
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x20000000
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x40000000
# SERVO_ALL_ABS_IN_BITMASK_RESERVED      = 0x80000000

# Output Bit-mask list
SERVO_ALL_ABS_OUT_BITMASK_COMPAREOUT = 0x00000001
SERVO_ALL_ABS_OUT_BITMASK_INPOSITION = 0x00000002
SERVO_ALL_ABS_OUT_BITMASK_ALARM = 0x00000004
SERVO_ALL_ABS_OUT_BITMASK_MOVING = 0x00000008
SERVO_ALL_ABS_OUT_BITMASK_ACCDEC = 0x00000010
SERVO_ALL_ABS_OUT_BITMASK_ACK = 0x00000020
SERVO_ALL_ABS_OUT_BITMASK_END = 0x00000040
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00000080
SERVO_ALL_ABS_OUT_BITMASK_ORGSEARCHOK = 0x00000100
SERVO_ALL_ABS_OUT_BITMASK_SERVOREADY = 0x00000200
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00000400
SERVO_ALL_ABS_OUT_BITMASK_BRAKE = 0x00000800
SERVO_ALL_ABS_OUT_BITMASK_PTOUT0 = 0x00001000
SERVO_ALL_ABS_OUT_BITMASK_PTOUT1 = 0x00002000
SERVO_ALL_ABS_OUT_BITMASK_PTOUT2 = 0x00004000
SERVO_ALL_ABS_OUT_BITMASK_PTOUT3 = 0x00008000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00010000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00020000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00040000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00080000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00100000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00200000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00400000
# SERVO_ALL_ABS_OUT_BITMASK_RESERVED     = 0x00800000

# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

SERVO_ALL_ABS_IN_PREASSIGN_LIMITP = 1
SERVO_ALL_ABS_IN_PREASSIGN_LIMITN = 2
SERVO_ALL_ABS_IN_PREASSIGN_ORIGIN = 3

SERVO_ALL_ABS_IN_LOGIC_CLEARPOSITION = 4
SERVO_ALL_ABS_IN_LOGIC_PTA0 = 5
SERVO_ALL_ABS_IN_LOGIC_PTA1 = 6
SERVO_ALL_ABS_IN_LOGIC_PTA2 = 7
SERVO_ALL_ABS_IN_LOGIC_PTA3 = 8
SERVO_ALL_ABS_IN_LOGIC_PTA4 = 9
SERVO_ALL_ABS_IN_LOGIC_PTA5 = 10
SERVO_ALL_ABS_IN_LOGIC_RESERVED0 = 11
SERVO_ALL_ABS_IN_LOGIC_RESERVED1 = 12
SERVO_ALL_ABS_IN_LOGIC_PTSTART = 13
SERVO_ALL_ABS_IN_LOGIC_STOP = 14
SERVO_ALL_ABS_IN_LOGIC_PJOG = 15
SERVO_ALL_ABS_IN_LOGIC_NJOG = 16
SERVO_ALL_ABS_IN_LOGIC_ALARMRESET = 17
SERVO_ALL_ABS_IN_LOGIC_SERVOON = 18
SERVO_ALL_ABS_IN_LOGIC_PAUSE = 19
SERVO_ALL_ABS_IN_LOGIC_ORIGINSEARCH = 20
SERVO_ALL_ABS_IN_LOGIC_TEACHING = 21
SERVO_ALL_ABS_IN_LOGIC_ESTOP = 22
SERVO_ALL_ABS_IN_LOGIC_JPTIN0 = 23
SERVO_ALL_ABS_IN_LOGIC_JPTIN1 = 24
SERVO_ALL_ABS_IN_LOGIC_JPTIN2 = 25
SERVO_ALL_ABS_IN_LOGIC_JPTSTART = 26
SERVO_ALL_ABS_IN_LOGIC_RESERVED2 = 27
SERVO_ALL_ABS_IN_LOGIC_RESERVED3 = 28
SERVO_ALL_ABS_IN_LOGIC_RESERVED4 = 29
SERVO_ALL_ABS_IN_LOGIC_RESERVED5 = 30
SERVO_ALL_ABS_IN_LOGIC_RESERVED6 = 31
SERVO_ALL_ABS_IN_LOGIC_RESERVED7 = 32

MAX_SERVO_ALL_ABS_IN_LOGIC = 33

SERVO_ALL_ABS_OUT_PREASSIGN_COMP = 1

SERVO_ALL_ABS_OUT_LOGIC_INPOSITION = 2
SERVO_ALL_ABS_OUT_LOGIC_ALARM = 3
SERVO_ALL_ABS_OUT_LOGIC_MOVING = 4
SERVO_ALL_ABS_OUT_LOGIC_ACCDEC = 5
SERVO_ALL_ABS_OUT_LOGIC_ACK = 6
SERVO_ALL_ABS_OUT_LOGIC_END = 7
SERVO_ALL_ABS_OUT_LOGIC_RESERVED0 = 8
SERVO_ALL_ABS_OUT_LOGIC_ORGSEARCHOK = 9
SERVO_ALL_ABS_OUT_LOGIC_SERVOREADY = 10
SERVO_ALL_ABS_OUT_LOGIC_RESERVED1 = 11
SERVO_ALL_ABS_OUT_LOGIC_BRAKE = 12
SERVO_ALL_ABS_OUT_LOGIC_PTOUT0 = 13
SERVO_ALL_ABS_OUT_LOGIC_PTOUT1 = 14
SERVO_ALL_ABS_OUT_LOGIC_PTOUT2 = 15
SERVO_ALL_ABS_OUT_LOGIC_PTOUT3 = 16
SERVO_ALL_ABS_OUT_LOGIC_RESERVED2 = 17
SERVO_ALL_ABS_OUT_LOGIC_RESERVED3 = 18
SERVO_ALL_ABS_OUT_LOGIC_RESERVED4 = 19
SERVO_ALL_ABS_OUT_LOGIC_RESERVED5 = 20
SERVO_ALL_ABS_OUT_LOGIC_RESERVED6 = 21
SERVO_ALL_ABS_OUT_LOGIC_RESERVED7 = 22
SERVO_ALL_ABS_OUT_LOGIC_RESERVED8 = 23
SERVO_ALL_ABS_OUT_LOGIC_RESERVED9 = 24

MAX_SERVO_ALL_ABS_OUT_LOGIC = 25

SERVO_ALL_ABS_IN_PIN_CNT = 9
SERVO_ALL_ABS_OUT_PIN_CNT = 9

SERVO_ALL_ABS_IN_LOGIC_CNT = MAX_SERVO_ALL_ABS_IN_LOGIC - 1
SERVO_ALL_ABS_MAX_PREASSIGNED_IN = SERVO_ALL_ABS_IN_PREASSIGN_ORIGIN

SERVO_ALL_ABS_OUT_LOGIC_CNT = MAX_SERVO_ALL_ABS_OUT_LOGIC - 1
SERVO_ALL_ABS_MAX_PREASSIGNED_OUT = SERVO_ALL_ABS_OUT_PREASSIGN_COMP

# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------

SERVO_ALL_ABS_PULSEPERREVOLUTION = 0
SERVO_ALL_ABS_AXISMAXSPEED = 1
SERVO_ALL_ABS_AXISSTARTSPEED = 2
SERVO_ALL_ABS_AXISACCTIME = 3
SERVO_ALL_ABS_AXISDECTIME = 4

SERVO_ALL_ABS_SPEEDOVERRIDE = 5
SERVO_ALL_ABS_JOGHIGHSPEED = 6
SERVO_ALL_ABS_JOGLOWSPEED = 7
SERVO_ALL_ABS_JOGACCDECTIME = 8

SERVO_ALL_ABS_SERVOALARMLOGIC = 9
SERVO_ALL_ABS_SERVOONLOGIC = 10
SERVO_ALL_ABS_SERVORESETLOGIC = 11

SERVO_ALL_ABS_SWLMTPLUSVALUE = 12
SERVO_ALL_ABS_SWLMTMINUSVALUE = 13
SERVO_ALL_ABS_SOFTLMTSTOPMETHOD = 14
SERVO_ALL_ABS_HARDLMTSTOPMETHOD = 15
SERVO_ALL_ABS_LIMITSENSORLOGIC = 16

SERVO_ALL_ABS_ORGSPEED = 17
SERVO_ALL_ABS_ORGSEARCHSPEED = 18
SERVO_ALL_ABS_ORGACCDECTIME = 19
SERVO_ALL_ABS_ORGMETHOD = 20
SERVO_ALL_ABS_ORGDIR = 21
SERVO_ALL_ABS_ORGOFFSET = 22
SERVO_ALL_ABS_ORGPOSITIONSET = 23
SERVO_ALL_ABS_ORGSENSORLOGIC = 24

SERVO_ALL_ABS_POSITIONLOOPGAIN = 25
SERVO_ALL_ABS_INPOSITIONVALUE = 26
SERVO_ALL_ABS_POSTRACKINGLIMIT = 27
SERVO_ALL_ABS_MOTIONDIR = 28

SERVO_ALL_ABS_LIMITSENSORDIR = 29
SERVO_ALL_ABS_ORGTORQUERATIO = 30

SERVO_ALL_ABS_POSERROVERFLOWLIMIT = 31

MAX_SERVO_ALL_ABS_PARAM = 32

# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

SERVO_ALL_ABS_MAX_ITEM_COUNT = 64
