# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------

DEVTYPE_EZI_STEP2_PLUS_R_ST = 130
DEVNAME_EZI_STEP2_PLUS_R_ST = "Ezi-STEP II Plus-R-ST"

# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------


class EZISTEP2_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_RESERVED2 = 0x00000080
    FFLAG_ERROVERCURRENT = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_RESERVED3 = 0x00000400
    FFLAG_RESERVED4 = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_RESERVED5 = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_RUNSTOP = 0x00080000
    FFLAG_STEPON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
STEP2_IN_BITMASK_LIMITP = 0x00000001
STEP2_IN_BITMASK_LIMITN = 0x00000002
STEP2_IN_BITMASK_ORIGIN = 0x00000004
STEP2_IN_BITMASK_CLEARPOSITION = 0x00000008
STEP2_IN_BITMASK_PTA0 = 0x00000010
STEP2_IN_BITMASK_PTA1 = 0x00000020
STEP2_IN_BITMASK_PTA2 = 0x00000040
STEP2_IN_BITMASK_PTA3 = 0x00000080
STEP2_IN_BITMASK_PTA4 = 0x00000100
STEP2_IN_BITMASK_PTA5 = 0x00000200
STEP2_IN_BITMASK_PTA6 = 0x00000400
STEP2_IN_BITMASK_PTA7 = 0x00000800
STEP2_IN_BITMASK_PTSTART = 0x00001000
STEP2_IN_BITMASK_STOP = 0x00002000
STEP2_IN_BITMASK_PJOG = 0x00004000
STEP2_IN_BITMASK_NJOG = 0x00008000
STEP2_IN_BITMASK_ALARMRESET = 0x00010000
# STEP2_IN_BITMASK_RESERVED = 0x00020000
STEP2_IN_BITMASK_PAUSE = 0x00040000
STEP2_IN_BITMASK_ORIGINSEARCH = 0x00080000
STEP2_IN_BITMASK_TEACHING = 0x00100000
STEP2_IN_BITMASK_ESTOP = 0x00200000
STEP2_IN_BITMASK_JPTIN0 = 0x00400000
STEP2_IN_BITMASK_JPTIN1 = 0x00800000
STEP2_IN_BITMASK_JPTIN2 = 0x01000000
STEP2_IN_BITMASK_JPTSTART = 0x02000000
STEP2_IN_BITMASK_USERIN0 = 0x04000000
STEP2_IN_BITMASK_USERIN1 = 0x08000000
STEP2_IN_BITMASK_USERIN2 = 0x10000000
STEP2_IN_BITMASK_USERIN3 = 0x20000000
STEP2_IN_BITMASK_USERIN4 = 0x40000000
STEP2_IN_BITMASK_USERIN5 = 0x80000000
STEP2_IN_BITMASK_USERIN6 = 0x00000200
STEP2_IN_BITMASK_USERIN7 = 0x00000400
STEP2_IN_BITMASK_USERIN8 = 0x00000800

# Output Bit-mask list
STEP2_OUT_BITMASK_COMPAREOUT = 0x00000001
# STEP2_OUT_BITMASK_RESERVED = 0x00000002
STEP2_OUT_BITMASK_ALARM = 0x00000004
STEP2_OUT_BITMASK_RUNSTOP = 0x00000008
STEP2_OUT_BITMASK_ACCDEC = 0x00000010
STEP2_OUT_BITMASK_ACK = 0x00000020
STEP2_OUT_BITMASK_END = 0x00000040
# STEP2_OUT_BITMASK_RESERVED = 0x00000080
STEP2_OUT_BITMASK_ORGSEARCHOK = 0x00000100
STEP2_OUT_BITMASK_STEPREADY = 0x00000200
# STEP2_OUT_BITMASK_RESERVED = 0x00000400
STEP2_OUT_BITMASK_BRAKE = 0x00000800
STEP2_OUT_BITMASK_PTOUT0 = 0x00001000
STEP2_OUT_BITMASK_PTOUT1 = 0x00002000
STEP2_OUT_BITMASK_PTOUT2 = 0x00004000
STEP2_OUT_BITMASK_USEROUT0 = 0x00008000
STEP2_OUT_BITMASK_USEROUT1 = 0x00010000
STEP2_OUT_BITMASK_USEROUT2 = 0x00020000
STEP2_OUT_BITMASK_USEROUT3 = 0x00040000
STEP2_OUT_BITMASK_USEROUT4 = 0x00080000
STEP2_OUT_BITMASK_USEROUT5 = 0x00100000
STEP2_OUT_BITMASK_USEROUT6 = 0x00200000
STEP2_OUT_BITMASK_USEROUT7 = 0x00400000
STEP2_OUT_BITMASK_USEROUT8 = 0x00800000


# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

STEP2_IN_PREASSIGN_LIMITP = 1
STEP2_IN_PREASSIGN_LIMITN = 2
STEP2_IN_PREASSIGN_ORIGIN = 3

STEP2_IN_LOGIC_CLEARPOSITION = 4
STEP2_IN_LOGIC_PTA0 = 5
STEP2_IN_LOGIC_PTA1 = 6
STEP2_IN_LOGIC_PTA2 = 7
STEP2_IN_LOGIC_PTA3 = 8
STEP2_IN_LOGIC_PTA4 = 9
STEP2_IN_LOGIC_PTA5 = 10
STEP2_IN_LOGIC_PTA6 = 11
STEP2_IN_LOGIC_PTA7 = 12
STEP2_IN_LOGIC_PTSTART = 13
STEP2_IN_LOGIC_STO = 14
STEP2_IN_LOGIC_PJOG = 15
STEP2_IN_LOGIC_NJOG = 16
STEP2_IN_LOGIC_ALARMRESET = 17
STEP2_IN_LOGIC_RESERVED0 = 18
STEP2_IN_LOGIC_PAUSE = 19
STEP2_IN_LOGIC_ORIGINSEARCH = 20
STEP2_IN_LOGIC_TEACHING = 21
STEP2_IN_LOGIC_ESTOP = 22
STEP2_IN_LOGIC_JPTIN0 = 23
STEP2_IN_LOGIC_JPTIN1 = 24
STEP2_IN_LOGIC_JPTIN2 = 25
STEP2_IN_LOGIC_JPTSTART = 26
STEP2_IN_LOGIC_USERIN0 = 27
STEP2_IN_LOGIC_USERIN1 = 28
STEP2_IN_LOGIC_USERIN2 = 29
STEP2_IN_LOGIC_USERIN3 = 30
STEP2_IN_LOGIC_USERIN4 = 31
STEP2_IN_LOGIC_USERIN5 = 32

MAX_STEP2_IN_LOGIC = 33


STEP2_OUT_PREASSIGN_COMP = 1

STEP2_OUT_LOGIC_RESERVED0 = 2
STEP2_OUT_LOGIC_ALARM = 3
STEP2_OUT_LOGIC_RUNSTOP = 4
STEP2_OUT_LOGIC_ACCDEC = 5
STEP2_OUT_LOGIC_ACK = 6
STEP2_OUT_LOGIC_END = 7
STEP2_OUT_LOGIC_RESERVED1 = 8
STEP2_OUT_LOGIC_ORGSEARCHOK = 9
STEP2_OUT_LOGIC_STEPREADY = 10
STEP2_OUT_LOGIC_RESERVED3 = 11
STEP2_OUT_LOGIC_BRAKE = 12
STEP2_OUT_LOGIC_PTOUT0 = 13
STEP2_OUT_LOGIC_PTOUT1 = 14
STEP2_OUT_LOGIC_PTOUT2 = 15
STEP2_OUT_LOGIC_USEROUT0 = 16
STEP2_OUT_LOGIC_USEROUT1 = 17
STEP2_OUT_LOGIC_USEROUT2 = 18
STEP2_OUT_LOGIC_USEROUT3 = 19
STEP2_OUT_LOGIC_USEROUT4 = 20
STEP2_OUT_LOGIC_USEROUT5 = 21
STEP2_OUT_LOGIC_USEROUT6 = 22
STEP2_OUT_LOGIC_USEROUT7 = 23
STEP2_OUT_LOGIC_USEROUT8 = 24

MAX_STEP2_OUT_LOGIC = 25


STEP2_IN_PIN_CNT = 12
STEP2_OUT_PIN_CNT = 10

STEP2_IN_LOGIC_CNT = MAX_STEP2_IN_LOGIC - 1
STEP2_MAX_PREASSIGNED_IN = STEP2_IN_PREASSIGN_ORIGIN

STEP2_OUT_LOGIC_CNT = MAX_STEP2_OUT_LOGIC - 1
STEP2_MAX_PREASSIGNED_OUT = STEP2_OUT_PREASSIGN_COMP

# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------


STEP2_PULSEPERREVOLUTION = 0
STEP2_AXISMAXSPEED = 1
STEP2_AXISSTARTSPEED = 2
STEP2_AXISACCTIME = 3
STEP2_AXISDECTIME = 4

STEP2_SPEEDOVERRIDE = 5
STEP2_JOGHIGHSPEED = 6
STEP2_JOGLOWSPEED = 7
STEP2_JOGACCDECTIME = 8

STEP2_SWLMTPLUSVALUE = 9
STEP2_SWLMTMINUSVALUE = 10
STEP2_SOFTLMTSTOPMETHOD = 11
STEP2_HARDLMTSTOPMETHOD = 12
STEP2_LIMITSENSORLOGIC = 13

STEP2_ORGSPEED = 14
STEP2_ORGSEARCHSPEED = 15
STEP2_ORGACCDECTIME = 16
STEP2_ORGMETHOD = 17
STEP2_ORGDIR = 18
STEP2_ORGOFFSET = 19
STEP2_ORGPOSITIONSET = 20
STEP2_ORGSENSORLOGIC = 21

STEP2_MOTIONDIR = 22
STEP2_LIMITSENSORDIR = 23
STEP2_BRAKEDELAYTIME = 24

STEP2_RUNCURRENT = 25
STEP2_BOOSTCURRENT = 26
STEP2_STOPCURRENT = 27

STEP2_ENCODERMULTIPLY = 28
STEP2_ENCODERDIR = 29

MAX_STEP2_PARAM = 30

# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

STEP2_MAX_ITEM_COUNT = 256
