# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------

DEVTYPE_EZI_STEP_PLUS_R_MINI = 60
DEVNAME_EZI_STEP_PLUS_R_MINI = "Ezi-STEP Plus-R-Mini"

# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------


class EZISTEP_MINI_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_ERRSTEPALARM = 0x00000080
    FFLAG_ERROVERCURRENT = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_ERRSTEPOUT = 0x00000400
    FFLAG_RESERVED2 = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_ERRLOWPOWER = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_RESERVED3 = 0x00080000
    FFLAG_RESERVED4 = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
STEP_MINI_IN_BITMASK_LIMITP = 0x00000001
STEP_MINI_IN_BITMASK_LIMITN = 0x00000002
STEP_MINI_IN_BITMASK_ORIGIN = 0x00000004
STEP_MINI_IN_BITMASK_CLEARPOSITION = 0x00000008
STEP_MINI_IN_BITMASK_PTA0 = 0x00000010
STEP_MINI_IN_BITMASK_PTA1 = 0x00000020
STEP_MINI_IN_BITMASK_PTA2 = 0x00000040
STEP_MINI_IN_BITMASK_PTA3 = 0x00000080
STEP_MINI_IN_BITMASK_PTA4 = 0x00000100
STEP_MINI_IN_BITMASK_PTA5 = 0x00000200
# STEP_MINI_IN_BITMASK_RESERVED      = 0x00000400
# STEP_MINI_IN_BITMASK_RESERVED      = 0x00000800
STEP_MINI_IN_BITMASK_PTSTART = 0x00001000
STEP_MINI_IN_BITMASK_STOP = 0x00002000
STEP_MINI_IN_BITMASK_PJOG = 0x00004000
STEP_MINI_IN_BITMASK_NJOG = 0x00008000
STEP_MINI_IN_BITMASK_ALARMRESET = 0x00010000
# STEP_MINI_IN_BITMASK_RESERVED      = 0x00020000
STEP_MINI_IN_BITMASK_PAUSE = 0x00040000
STEP_MINI_IN_BITMASK_ORIGINSEARCH = 0x00080000
STEP_MINI_IN_BITMASK_TEACHING = 0x00100000
STEP_MINI_IN_BITMASK_ESTOP = 0x00200000
STEP_MINI_IN_BITMASK_JPTIN0 = 0x00400000
STEP_MINI_IN_BITMASK_JPTIN1 = 0x00800000
STEP_MINI_IN_BITMASK_JPTIN2 = 0x01000000
STEP_MINI_IN_BITMASK_JPTSTART = 0x02000000
STEP_MINI_IN_BITMASK_USERIN0 = 0x04000000
STEP_MINI_IN_BITMASK_USERIN1 = 0x08000000
STEP_MINI_IN_BITMASK_USERIN2 = 0x10000000
STEP_MINI_IN_BITMASK_USERIN3 = 0x20000000
STEP_MINI_IN_BITMASK_USERIN4 = 0x40000000
STEP_MINI_IN_BITMASK_USERIN5 = 0x80000000
STEP_MINI_IN_BITMASK_USERIN6 = 0x00000200

# Output Bit-mask list
STEP_MINI_OUT_BITMASK_COMPAREOUT = 0x00000001
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00000002
STEP_MINI_OUT_BITMASK_ALARM = 0x00000004
STEP_MINI_OUT_BITMASK_RUNSTOP = 0x00000008
STEP_MINI_OUT_BITMASK_ACCDEC = 0x00000010
STEP_MINI_OUT_BITMASK_ACK = 0x00000020
STEP_MINI_OUT_BITMASK_END = 0x00000040
STEP_MINI_OUT_BITMASK_ALARMBLINK = 0x00000080
STEP_MINI_OUT_BITMASK_ORGSEARCHOK = 0x00000100
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00000200
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00000400
STEP_MINI_OUT_BITMASK_BRAKE = 0x00000800
STEP_MINI_OUT_BITMASK_PTOUT0 = 0x00001000
STEP_MINI_OUT_BITMASK_PTOUT1 = 0x00002000
STEP_MINI_OUT_BITMASK_PTOUT2 = 0x00004000
STEP_MINI_OUT_BITMASK_USEROUT0 = 0x00008000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00010000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00020000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00040000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00080000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00100000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00200000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00400000
# STEP_MINI_OUT_BITMASK_RESERVED     = 0x00800000


# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

STEP_MINI_IN_PREASSIGN_LIMITP = 1
STEP_MINI_IN_PREASSIGN_LIMITN = 2
STEP_MINI_IN_PREASSIGN_ORIGIN = 3

STEP_MINI_IN_LOGIC_CLEARPOSITION = 4
STEP_MINI_IN_LOGIC_PTA0 = 5
STEP_MINI_IN_LOGIC_PTA1 = 6
STEP_MINI_IN_LOGIC_PTA2 = 7
STEP_MINI_IN_LOGIC_PTA3 = 8
STEP_MINI_IN_LOGIC_PTA4 = 9
STEP_MINI_IN_LOGIC_PTA5 = 10
STEP_MINI_IN_LOGIC_RESERVED0 = 11
STEP_MINI_IN_LOGIC_RESERVED1 = 12
STEP_MINI_IN_LOGIC_PTSTART = 13
STEP_MINI_IN_LOGIC_STOP = 14
STEP_MINI_IN_LOGIC_PJOG = 15
STEP_MINI_IN_LOGIC_NJOG = 16
STEP_MINI_IN_LOGIC_ALARMRESET = 17
STEP_MINI_IN_LOGIC_RESERVED2 = 18
STEP_MINI_IN_LOGIC_PAUSE = 19
STEP_MINI_IN_LOGIC_ORIGINSEARCH = 20
STEP_MINI_IN_LOGIC_TEACHING = 21
STEP_MINI_IN_LOGIC_ESTOP = 22
STEP_MINI_IN_LOGIC_JPTIN0 = 23
STEP_MINI_IN_LOGIC_JPTIN1 = 24
STEP_MINI_IN_LOGIC_JPTIN2 = 25
STEP_MINI_IN_LOGIC_JPTSTART = 26
STEP_MINI_IN_LOGIC_USERIN0 = 27
STEP_MINI_IN_LOGIC_USERIN1 = 28
STEP_MINI_IN_LOGIC_USERIN2 = 29
STEP_MINI_IN_LOGIC_USERIN3 = 30
STEP_MINI_IN_LOGIC_USERIN4 = 31
STEP_MINI_IN_LOGIC_USERIN5 = 32

MAX_STEP_MINI_IN_LOGIC = 33


STEP_MINI_OUT_PREASSIGN_COMP = 1

STEP_MINI_OUT_LOGIC_RESERVED0 = 2
STEP_MINI_OUT_LOGIC_ALARM = 3
STEP_MINI_OUT_LOGIC_RUNSTOP = 4
STEP_MINI_OUT_LOGIC_ACCDEC = 5
STEP_MINI_OUT_LOGIC_ACK = 6
STEP_MINI_OUT_LOGIC_END = 7
STEP_MINI_OUT_LOGIC_ALARMBLINK = 8
STEP_MINI_OUT_LOGIC_ORGSEARCHOK = 9
STEP_MINI_OUT_LOGIC_RESERVED1 = 10
STEP_MINI_OUT_LOGIC_RESERVED2 = 11
STEP_MINI_OUT_LOGIC_BRAKE = 12
STEP_MINI_OUT_LOGIC_PTOUT0 = 13
STEP_MINI_OUT_LOGIC_PTOUT1 = 14
STEP_MINI_OUT_LOGIC_PTOUT2 = 15
STEP_MINI_OUT_LOGIC_USEROUT0 = 16
STEP_MINI_OUT_LOGIC_RESERVED3 = 17
STEP_MINI_OUT_LOGIC_RESERVED4 = 18
STEP_MINI_OUT_LOGIC_RESERVED5 = 19
STEP_MINI_OUT_LOGIC_RESERVED6 = 20
STEP_MINI_OUT_LOGIC_RESERVED7 = 21
STEP_MINI_OUT_LOGIC_RESERVED8 = 22
STEP_MINI_OUT_LOGIC_RESERVED9 = 23
STEP_MINI_OUT_LOGIC_RESERVED10 = 24

MAX_STEP_MINI_OUT_LOGIC = 25


STEP_MINI_IN_PIN_CNT = 10
STEP_MINI_OUT_PIN_CNT = 2

STEP_MINI_IN_LOGIC_CNT = MAX_STEP_MINI_IN_LOGIC - 1
STEP_MINI_MAX_PREASSIGNED_IN = STEP_MINI_IN_PREASSIGN_ORIGIN

STEP_MINI_OUT_LOGIC_CNT = MAX_STEP_MINI_OUT_LOGIC - 1
STEP_MINI_MAX_PREASSIGNED_OUT = STEP_MINI_OUT_PREASSIGN_COMP

# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------

STEP_MINI_PULSEPERREVOLUTION = 0
STEP_MINI_AXISMAXSPEED = 1
STEP_MINI_AXISSTARTSPEED = 2
STEP_MINI_AXISACCTIME = 3
STEP_MINI_AXISDECTIME = 4

STEP_MINI_SPEEDOVERRIDE = 5
STEP_MINI_JOGHIGHSPEED = 6
STEP_MINI_JOGLOWSPEED = 7
STEP_MINI_JOGACCDECTIME = 8

STEP_MINI_ALARMLOGIC = 9
STEP_MINI_RUNSTOPSIGNALLOGIC = 10  # ERVO_SERVOONLOGIC,
STEP_MINI_RESETLOGIC = 11

STEP_MINI_SWLMTPLUSVALUE = 12
STEP_MINI_SWLMTMINUSVALUE = 13
STEP_MINI_SOFTLMTSTOPMETHOD = 14
STEP_MINI_HARDLMTSTOPMETHOD = 15
STEP_MINI_LIMITSENSORLOGIC = 16

STEP_MINI_ORGSPEED = 17
STEP_MINI_ORGSEARCHSPEED = 18
STEP_MINI_ORGACCDECTIME = 19
STEP_MINI_ORGMETHOD = 20
STEP_MINI_ORGDIR = 21
TEP_MINI_ORGOFFSET = 22
STEP_MINI_ORGPOSITIONSET = 23
STEP_MINI_ORGSENSORLOGI = 24

STEP_MINI_STOPCURRENT = 25
STEP_MINI_MOTIONDIR = 26

STEP_MINI_LIMITSENSORDIR = 27
STEP_MINI_ENCODERMULTIVALUE = 28

STEP_MINI_ENCODERDIR = 29
STEP_MINI_POSVALUECOUNTINGMETHOD = 30

MAX_STEP_MINI_PARAM = 31

# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

STEP_MINI_MAX_ITEM_COUNT = 64
