# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------

DEVTYPE_S_SERVO_PLUS_R_ST = 102
DEVNAME_S_SERVO_PLUS_R_ST = "S-SERVO Plus-R-ST"

# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------


class SSERVO_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_ERRPOSOVERFLOW = 0x00000080
    FFLAG_ERROVERCURRENT = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_ERRPOSTRACKING = 0x00000400
    FFLAG_ERROVERLOAD = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_ERRINPOSITION = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
SSERVO_IN_BITMASK_LIMITP = 0x00000001
SSERVO_IN_BITMASK_LIMITN = 0x00000002
SSERVO_IN_BITMASK_ORIGIN = 0x00000004
SSERVO_IN_BITMASK_CLEARPOSITION = 0x00000008
SSERVO_IN_BITMASK_PTA0 = 0x00000010
SSERVO_IN_BITMASK_PTA1 = 0x00000020
SSERVO_IN_BITMASK_PTA2 = 0x00000040
SSERVO_IN_BITMASK_PTA3 = 0x00000080
SSERVO_IN_BITMASK_PTA4 = 0x00000100
SSERVO_IN_BITMASK_PTA5 = 0x00000200
SSERVO_IN_BITMASK_PTA6 = 0x00000400
SSERVO_IN_BITMASK_PTA7 = 0x00000800
SSERVO_IN_BITMASK_PTSTART = 0x00001000
SSERVO_IN_BITMASK_STOP = 0x00002000
SSERVO_IN_BITMASK_PJOG = 0x00004000
SSERVO_IN_BITMASK_NJOG = 0x00008000
SSERVO_IN_BITMASK_ALARMRESET = 0x00010000
SSERVO_IN_BITMASK_SERVOON = 0x00020000
SSERVO_IN_BITMASK_PAUSE = 0x00040000
SSERVO_IN_BITMASK_ORIGINSEARCH = 0x00080000
SSERVO_IN_BITMASK_TEACHING = 0x00100000
SSERVO_IN_BITMASK_ESTOP = 0x00200000
SSERVO_IN_BITMASK_JPTIN0 = 0x00400000
SSERVO_IN_BITMASK_JPTIN1 = 0x00800000
SSERVO_IN_BITMASK_JPTIN2 = 0x01000000
SSERVO_IN_BITMASK_JPTSTART = 0x02000000
SSERVO_IN_BITMASK_USERIN0 = 0x04000000
SSERVO_IN_BITMASK_USERIN1 = 0x08000000
SSERVO_IN_BITMASK_USERIN2 = 0x10000000
SSERVO_IN_BITMASK_USERIN3 = 0x20000000
SSERVO_IN_BITMASK_USERIN4 = 0x40000000
SSERVO_IN_BITMASK_USERIN5 = 0x80000000
SSERVO_IN_BITMASK_USERIN6 = 0x00000200
SSERVO_IN_BITMASK_USERIN7 = 0x00000400
SSERVO_IN_BITMASK_USERIN8 = 0x00000800

# Output Bit-mask list
SSERVO_OUT_BITMASK_COMPAREOUT = 0x00000001
SSERVO_OUT_BITMASK_INPOSITION = 0x00000002
SSERVO_OUT_BITMASK_ALARM = 0x00000004
SSERVO_OUT_BITMASK_MOVING = 0x00000008
SSERVO_OUT_BITMASK_ACCDEC = 0x00000010
SSERVO_OUT_BITMASK_ACK = 0x00000020
SSERVO_OUT_BITMASK_END = 0x00000040
SSERVO_OUT_BITMASK_PUSHDETECT = 0x00000080
SSERVO_OUT_BITMASK_ORGSEARCHOK = 0x00000100
SSERVO_OUT_BITMASK_SERVOREADY = 0x00000200
# SSERVO_OUT_BITMASK_RESERVED = 0x00000400
SSERVO_OUT_BITMASK_BRAKE = 0x00000800
SSERVO_OUT_BITMASK_PTOUT0 = 0x00001000
SSERVO_OUT_BITMASK_PTOUT1 = 0x00002000
SSERVO_OUT_BITMASK_PTOUT2 = 0x00004000
SSERVO_OUT_BITMASK_USEROUT0 = 0x00008000
SSERVO_OUT_BITMASK_USEROUT1 = 0x00010000
SSERVO_OUT_BITMASK_USEROUT2 = 0x00020000
SSERVO_OUT_BITMASK_USEROUT3 = 0x00040000
SSERVO_OUT_BITMASK_USEROUT4 = 0x00080000
SSERVO_OUT_BITMASK_USEROUT5 = 0x00100000
SSERVO_OUT_BITMASK_USEROUT6 = 0x00200000
SSERVO_OUT_BITMASK_USEROUT7 = 0x00400000
SSERVO_OUT_BITMASK_USEROUT8 = 0x00800000


# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

SSERVO_IN_PREASSIGN_LIMITP = 1
SSERVO_IN_PREASSIGN_LIMITN = 2
SSERVO_IN_PREASSIGN_ORIGIN = 3

SSERVO_IN_LOGIC_CLEARPOSITION = 4
SSERVO_IN_LOGIC_PTA0 = 5
SSERVO_IN_LOGIC_PTA1 = 6
SSERVO_IN_LOGIC_PTA2 = 7
SSERVO_IN_LOGIC_PTA3 = 8
SSERVO_IN_LOGIC_PTA4 = 9
SSERVO_IN_LOGIC_PTA5 = 10
SSERVO_IN_LOGIC_PTA6 = 11
SSERVO_IN_LOGIC_PTA7 = 12
SSERVO_IN_LOGIC_PTSTART = 13
SSERVO_IN_LOGIC_STOP = 14
SSERVO_IN_LOGIC_PJOG = 15
SSERVO_IN_LOGIC_NJOG = 16
SSERVO_IN_LOGIC_ALARMRESET = 17
SSERVO_IN_LOGIC_SERVOON = 18
SSERVO_IN_LOGIC_PAUSE = 19
SSERVO_IN_LOGIC_ORIGINSEARCH = 20
SSERVO_IN_LOGIC_TEACHING = 21
SSERVO_IN_LOGIC_ESTOP = 22
SSERVO_IN_LOGIC_JPTIN0 = 23
SSERVO_IN_LOGIC_JPTIN1 = 24
SSERVO_IN_LOGIC_JPTIN2 = 25
SSERVO_IN_LOGIC_JPTSTART = 26
SSERVO_IN_LOGIC_USERIN0 = 27
SSERVO_IN_LOGIC_USERIN1 = 28
SSERVO_IN_LOGIC_USERIN2 = 29
SSERVO_IN_LOGIC_USERIN3 = 30
SSERVO_IN_LOGIC_USERIN4 = 31
SSERVO_IN_LOGIC_USERIN5 = 32

MAX_SSERVO_IN_LOGIC = 33


SSERVO_OUT_PREASSIGN_COMP = 1

SSERVO_OUT_LOGIC_INPOSITION = 2
SSERVO_OUT_LOGIC_ALARM = 3
SSERVO_OUT_LOGIC_MOVING = 4
SSERVO_OUT_LOGIC_ACCDEC = 5
SSERVO_OUT_LOGIC_ACK = 6
SSERVO_OUT_LOGIC_END = 7
SSERVO_OUT_LOGIC_PUSHDETECT = 8
SSERVO_OUT_LOGIC_ORGSEARCHOK = 9
SSERVO_OUT_LOGIC_SERVOREADY = 10
SSERVO_OUT_LOGIC_RESERVED0 = 11
SSERVO_OUT_LOGIC_BRAKE = 12
SSERVO_OUT_LOGIC_PTOUT0 = 13
SSERVO_OUT_LOGIC_PTOUT1 = 14
SSERVO_OUT_LOGIC_PTOUT2 = 15
SSERVO_OUT_LOGIC_USEROUT0 = 16
SSERVO_OUT_LOGIC_USEROUT1 = 17
SSERVO_OUT_LOGIC_USEROUT2 = 18
SSERVO_OUT_LOGIC_USEROUT3 = 19
SSERVO_OUT_LOGIC_USEROUT4 = 20
SSERVO_OUT_LOGIC_USEROUT5 = 21
SSERVO_OUT_LOGIC_USEROUT6 = 22
SSERVO_OUT_LOGIC_USEROUT7 = 23
SSERVO_OUT_LOGIC_USEROUT8 = 24

MAX_SSERVO_OUT_LOGIC = 25

SSERVO_IN_PIN_CNT = 12
SSERVO_OUT_PIN_CNT = 10

SSERVO_IN_LOGIC_CNT = MAX_SSERVO_IN_LOGIC - 1
SSERVO_MAX_PREASSIGNED_IN = SSERVO_IN_PREASSIGN_ORIGIN

SSERVO_OUT_LOGIC_CNT = MAX_SSERVO_OUT_LOGIC - 1
SSERVO_MAX_PREASSIGNED_OUT = SSERVO_OUT_PREASSIGN_COMP

# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------

SSERVO_PULSEPERREVOLUTION = 0
SSERVO_AXISMAXSPEED = 1
SSERVO_AXISSTARTSPEED = 2
SSERVO_AXISACCTIME = 3
SSERVO_AXISDECTIME = 4

SSERVO_SPEEDOVERRIDE = 5
SSERVO_JOGHIGHSPEED = 6
SSERVO_JOGLOWSPEED = 7
SSERVO_JOGACCDECTIME = 8

SSERVO_SWLMTPLUSVALUE = 9
SSERVO_SWLMTMINUSVALUE = 10
SSERVO_SOFTLMTSTOPMETHOD = 11
SSERVO_HARDLMTSTOPMETHOD = 12
SSERVO_LIMITSENSORLOGIC = 13

SSERVO_ORGSPEED = 14
SSERVO_ORGSEARCHSPEED = 15
SSERVO_ORGACCDECTIME = 16
SSERVO_ORGMETHOD = 17
SSERVO_ORGDIR = 18
SSERVO_ORGOFFSET = 19
SSERVO_ORGPOSITIONSET = 20
SSERVO_ORGSENSORLOGIC = 21

SSERVO_POSITIONLOOPGAIN = 22
SSERVO_INPOSITIONVALUE = 23
SSERVO_POSTRACKINGLIMIT = 24
SSERVO_MOTIONDIR = 25

SSERVO_LIMITSENSORDIR = 26
SSERVO_ORGTORQUERATIO = 27

SSERVO_POSERROVERFLOWLIMIT = 28
SSERVO_BRAKEDELAYTIME = 29

SSERVO_RUNCURRENT = 30
SSERVO_BOOSTCURRENT = 31
SSERVO_STOPCURRENT = 32
MAX_SSERVO_PARAM = 33


# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

SSERVO_MAX_ITEM_COUNT = 256
